%define __os_install_post    /usr/lib/rpm/brp-compress /usr/lib/rpm/brp-strip %{__strip} /usr/lib/rpm/brp-strip-comment-note %{__strip} %{__objdump} %{nil}
%global momorel 6

Name: mjpegtools
Version: 1.8.0
Release: %{momorel}m
Summary: Tools for recording, editing, playing back and mpeg-encoding video under linux
License: GPL
URL: http://mjpeg.sourceforge.net/
Group: Applications/Multimedia
%NoSource 0 http://jaist.dl.sourceforge.net/sourceforge/mjpeg/mjpegtools-%{version}.tar.gz 6fd98362310480bdaf7171e9659f165f
%NoSource 1 http://jaist.dl.sourceforge.net/sourceforge/mjpeg/quicktime4linux-1.4-patched-2.tar.gz 064fdc76dd296761f88550be5d0fbda2
%NoSource 2 http://jaist.dl.sourceforge.net/sourceforge/mjpeg/libmovtar-0.1.3.tar.gz 3810ba83a90c52676014ab1ea6d8cd9f
%NoSource 3 http://jaist.dl.sourceforge.net/sourceforge/mjpeg/jpeg-mmx-0.1.6.tar.gz 9156c429bd8c4dea65c877c50ed89e15
#Patch1: mjpegtools-1.6.2-kernel2681.patch
Patch2: quicktime4linux-1.4-gcc34.patch
Patch3: jpeg-mmx-0.1.6-gcc34.patch
Patch4: libmovtar-0.1.3-gcc34.patch
Patch5: libmovtar-0.1.3-gcc4.patch
#Patch6: mjpegtools-1.6.2-unsigned_long_long.patch
Patch7: movtar.m4.patch
Patch8: mjpegtools-1.8.0-EM64T.patch
Patch100: mjpegtools-1.8.0-fix_constraint_in_inline_asm.diff
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPreReq: SDL-devel >= 1.2.7-11m, arts-devel, esound-devel
BuildPreReq: freetype2-devel, libdv >= 0.98-1m
BuildPreReq: libjpeg-devel, libpng-devel
BuildPreReq: avifile >= 0.7.40-0.20040419.5m
BuildPreReq: gcc-c++ >= 3.4.1-1m

%description
The MJPEG-tools are a basic set of utilities for recording, editing, 
playing back and encoding (to mpeg) video under linux. Recording can
be done with zoran-based MJPEG-boards (LML33, Iomega Buz, Pinnacle
DC10(+), Marvel G200/G400), these can also playback video using the
hardware. With the rest of the tools, this video can be edited and
encoded into mpeg1/2 or divx video.

%package devel
Summary: Development headers and libraries for the mjpegtools
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains static libraries and C system header files
needed to compile applications that use part of the libraries
of the mjpegtools package.

%prep
%setup -q -n %{name}-%{version} -a 1 -a 2 -a 3
#%%patch1 -p1 -b .kernel2681~
%patch2 -p0 -b .gcc34
%patch3 -p0 -b .gcc34
%patch4 -p0 -b .gcc34
%patch5 -p0 -b .gcc4
%ifarch x86_64
%patch8 -p1 -b .EM64T
%endif

mv quicktime4linux-* quicktime4linux
mv libmovtar-* libmovtar

#patch6 -p1 -b .ull~
%patch7 -p0 -b .m4~

%patch100 -p1 -b .gcc41~

mkdir usr

%build
tmp_prefix="`pwd`/usr"
mkdir -p $tmp_prefix/{include,lib,bin,share}

CFLAGS="`echo ${CFLAGS:-%optflags}|sed -e 's, -funroll-loops,,'|sed -e 's, -fstack-protector,,'`" ; export CFLAGS
CXXFLAGS="${CXXFLAGS:-%optflags}" ; export CXXFLAGS

# add -fpermissive
# build error gcc-4.1
case "`gcc -dumpversion`" in
4.1.*)
export CXXFLAGS="$CXXFLAGS -fpermissive"
  ;;
esac

%ifarch %{ix86}
(cd jpeg-mmx && ./configure)
make -C jpeg-mmx libjpeg-mmx.a
%endif

(cd quicktime4linux && \
%ifarch %{ix86}
./configure --use-dv --use-firewire
%else 
./configure --no-mmx --use-dv --use-firewire
%endif
)
make -C quicktime4linux
rm -rf quicktime4linux/libdv

%ifarch %{ix86}
CONF_ARGS="--with-jpeg-mmx=`pwd`/jpeg-mmx"

(cd libmovtar && 
   ./configure --prefix="$tmp_prefix" \
	--with-m4data-prefix="$tmp_prefix/share/aclocal" \
	$CONF_ARGS )

make -C libmovtar
make -C libmovtar install
%endif

CONF_ARGS="$CONF_ARGS --prefix=%{_prefix} --libdir=%{_libdir}"

%ifarch %{ix86}
(cd libmovtar&& ./configure $CONF_ARGS)
make -C libmovtar
%endif

CONF_ARGS="$CONF_ARGS --with-quicktime=`pwd`/quicktime4linux"
%ifarch %{ix86}
CONF_ARGS="$CONF_ARGS --with-movtar-prefix=$tmp_prefix"
MOVTAR_CONFIG=$tmp_prefix/bin/movtar-config; export MOVTAR_CONFIG
%else
CONF_ARGS="$CONF_ARGS --disable-simd-accel"
%endif
./configure $CONF_ARGS --enable-large-file --enable-cmov-extension
%make

%install
rm -rf %{buildroot}
%ifarch %{ix86}
%makeinstall -C libmovtar m4datadir=%{buildroot}%{_datadir}/aclocal
%endif
%makeinstall
# remove unnecessary dependencies
perl -p -i -e 's, -lquicktime,,' %{buildroot}%{_libdir}/*la
perl -p -i -e 's, -ljpeg-mmx,,' %{buildroot}%{_libdir}/*la
perl -p -i -e "s, -L`pwd`/jpeg-mmx,," %{buildroot}%{_libdir}/*la
perl -p -i -e 's, -L/usr/local/lib,,' %{buildroot}%{_libdir}/*la
rm -f %{buildroot}%{_bindir}/multiblend.flt
rm -f %{buildroot}%{_infodir}/dir

%post
/sbin/ldconfig

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc AUTHORS BUGS CHANGES COPYING HINTS PLANS README TODO
%{_bindir}/pgmtoy4m
%{_bindir}/yuvfps
%{_bindir}/yuvinactive
%{_bindir}/glav
%{_bindir}/jpeg2yuv
%{_bindir}/lav2avi.sh
%{_bindir}/lav2mpeg
%{_bindir}/lav2wav
%{_bindir}/lav2yuv
%{_bindir}/lavaddwav
%{_bindir}/lavinfo
%{_bindir}/lavpipe
%{_bindir}/lavplay
%{_bindir}/lavrec
%{_bindir}/lavtrans
%{_bindir}/lavvideo
%{_bindir}/matteblend.flt
%{_bindir}/mp2enc
%{_bindir}/mpeg2enc
%{_bindir}/mpegtranscode
%{_bindir}/mplex
%{_bindir}/png2yuv
%{_bindir}/ppmtoy4m
%{_bindir}/testrec
%{_bindir}/transist.flt
%{_bindir}/y4mblack
%{_bindir}/y4mcolorbars
%{_bindir}/y4mshift
%{_bindir}/y4mtoppm
%{_bindir}/y4mtoyuv
%{_bindir}/y4mdenoise
%{_bindir}/y4mhist
%{_bindir}/y4minterlace
%{_bindir}/y4mspatialfilter
%{_bindir}/y4mstabilizer
%{_bindir}/y4mtopnm
%{_bindir}/y4munsharp
%{_bindir}/ypipe
%{_bindir}/yuv2lav
%{_bindir}/yuv4mpeg
%{_bindir}/yuvcorrect
%{_bindir}/yuvcorrect_tune
%{_bindir}/yuvdenoise
%{_bindir}/yuvkineco
%{_bindir}/yuvmedianfilter
%{_bindir}/yuvplay
%{_bindir}/yuvscaler
%{_bindir}/yuvycsnoise
%{_bindir}/yuvdeinterlace
%{_bindir}/yuyvtoy4m
%{_bindir}/anytovcd.sh
%{_bindir}/mjpeg_simd_helper
%{_bindir}/pnmtoy4m
%{_libdir}/*.so.*
%{_mandir}/man1/*
%{_mandir}/man5/*
%ifarch %{ix86}
%{_bindir}/movtar_index
%{_bindir}/movtar_play
%{_bindir}/movtar_setinfo
%{_bindir}/movtar_split
%{_bindir}/movtar_unify
%{_bindir}/movtar_yuv422
%{_bindir}/pnm2rtj
%{_bindir}/rtjshow
%endif
%{_infodir}/mjpeg-howto.info*

%files devel
%defattr(-,root,root)
%ifarch %{ix86}
%{_bindir}/movtar-config
%endif
%{_includedir}/mjpegtools
%ifarch %{ix86}
%{_includedir}/movtar.h
%{_datadir}/aclocal/*.m4
%endif
%{_libdir}/pkgconfig/*.pc
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so

%changelog
* Mon Jul 31 2006 Nishio Futoshi <futoshi@momonga-linuc.org>
- (1.8.0-6m)
- remove patch1

* Mon Jan  9 2006 YAMAZAKI Makoto <zaki@zakky.org>
- (1.8.0-5m)
- fixed build error gcc-4.1
   jpeg-mmx/jquant_x86simd.c: use specific operand constraint instead of almighty operand constraint "X"
   quicktime4linux/libdv/mmx.h: use specific operand constraint instead of almighty operand constraint "X"

* Sun Dec 25 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (1.8.0-4m)
- fix build error gcc-4.1
-- if used gcc-4.x
--  export CXXFLAGS="$CXXFLAGS -fpermissive"

* Sat Dec 10 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.8.0-3m)
- add Patch8: mjpegtools-1.8.0-EM64T.patch (for EM64T Pentium4/D & Xeon)

* Tue Nov 22 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (1.8.0-2m)
- fixed not ix86 arch.

* Wed Nov 18 2005 Hiroyuki Koga <kuma@momonga-linux.org>
- (1.8.0-1m)
- version up
- update Patch3: jpeg-mmx-0.1.6-gcc34.patch
- remove Patch5: mjpegtools-1.6.2-gcc34.patch
         Patch6: mjpegtools-1.6.2-unsigned_long_long.patch
- add    Patch5: libmovtar-0.1.3-gcc4.patch

* Fri May 20 2005 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.6.2.12m)
- suppress AC_DEFUN warning.

* Sat Feb 26 2005 YAMAZAKI Makoto <zaki@zakky.org>
- (1.6.2-11m)
- append ULL to unsigned long long immediate values;

* Sat Feb 26 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.6.2-10m)
- rebuild against SDL

* Sun Feb 20 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (1.6.2-9m)
- enable x86_64.
- fix *.la

* Sat Feb 12 2005 Kazuhiko <kazuhiko@fdiary.net>
- (1.6.2-8m)
- rebuild against SDL-1.2.7-10m

* Sun Feb  6 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (1.6.2-7m)
- enable ppc.

* Mon Sep 27 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (1.6.2-6m)
- rebuild against gcc-c++-3.4.1
- add BuildPrereq: gcc-c++
- add gcc34 patch

* Sun Aug 29 2004 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (1.6.2-5m)
- build against SDL-1.2.7-3m
- add Patch1:  mjpegtools-1.6.2-kernel2681.patch

* Sun Aug 29 2004 Kazuhiko <kazuhiko@fdiary.net>
- (1.6.2-4m)
- rebuild against DirectFB-0.9.21

* Thu Jun 17 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (1.6.2-3m)
- rebuild against libdv-0.102

* Sat May  1 2004 Toru Hoshina <t@momonga-linux.org>
- (1.6.2-2m)
- revised spec for rpm 4.2.1.

* Thu Apr 29 2004 Masayuki SANO <nosanosa@momonga-linux.org>
- (1.6.2-1m)
- update mjepgtools to 1.6.2, jpeg-mmx to 0.1.5
- - ommit -fstak-protector from CFLAGS (avoid internal compiler error in making lavtools/yuvscaler)
- - *divx* tools has been replaced by lav2avi.sh
- - some new tools

* Tue Mar 23 2004 Toru Hoshina <t@momonga-linux.org>
- (1.6.1-2m)
- revised spec for enabling rpm 4.2.

* Wed Jun  4 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.6.1-1m)
  update to 1.6.1(rebuild against DirectFB 0.9.18)

* Sat Mar 08 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (1.6.0-10m)
- rebuild against for XFree86-4.3.0

* Wed Jan 15 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.6.0-9m)
- add defattr at files devel section

* Fri Jan 10 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.6.0-8m)
- BuildPreReq: libdv >= 0.98-1m for libdv.so.2

* Fri Jan 3 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.6.0-7m)
- rebuild against for libdv

* Thu Jan 2 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.6.0-6m)
- add BuildPreReq: libdv >= 0.9.5-9m for /usr/lib/libdv.so

* Sun Dec 29 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.6.0-5m)
- remove unnecessary dependencies from '*.la'

* Sun Dec 15 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.6.0-4m)
- revise for ppc and spec cleanup

* Sat Nov  2 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.6.0-3m)
- add --with-dv-prefix=%{_includedir}/libdv

* Wed Oct 30 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.6.0-2m)
- enable dv and firewire on building quicktime4linux

* Tue Oct 29 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.6.0-1m)

* Tue Feb 12 2002 Geoffrey T. Dairiki <dairiki@dairiki.org>
- Fix spec file to build in one directory, etc...

* Thu Dec 06 2001 Ronald Bultje <rbultje@ronald.bitfreak.net>
- separated mjpegtools and mjpegtools-devel
- added changes by Marcel Pol <mpol@gmx.net> for cleaner RPM build

* Wed Jun 06 2001 Ronald Bultje <rbultje@ronald.bitfreak.net>
- 1.4.0-final release, including precompiled binaries (deb/rpm)
